#include <pspsdk.h>
#include <pspkernel.h>
#include <pspctrl.h>
#include <pspiofilemgr.h>
#include <pspdebug.h>
#include <psppower.h>
#include <pspidstorage.h>
 
PSP_MODULE_INFO("idstorage_copy", 0x1000, 1, 0);
PSP_MAIN_THREAD_ATTR(0);
 
#define printf pspDebugScreenPrintf
 
char buffer[512];

int waitforbutton(void) {
        SceCtrlData pad;
        while (1) {
        	    sceCtrlReadBufferPositive(&pad, 1);
                if(pad.Buttons & PSP_CTRL_CROSS) return 1;
                if(pad.Buttons & PSP_CTRL_CIRCLE) return 0;
                sceKernelDelayThread(10000);
        }
}

int main(void) {
        int x;
        SceCtrlData pad;

        pspDebugScreenInit();

    	sceCtrlSetSamplingCycle(0);
    	sceCtrlSetSamplingMode(PSP_CTRL_MODE_DIGITAL);

        if(scePowerGetBatteryLifePercent() < 50) {
                printf("Battery has to be atleast 50%%.\n");
                sceKernelDelayThread(3000 * 3000);
                sceKernelExitGame();
        }

        printf("This app copies IdStorage key 5 to key 4.\n");
        printf("By running this app, you understand the risks involved and in no way is anyone responsible besides yourself.\n\n");
        printf("Press X to copy keys or O to exit.\n\n");
        if(waitforbutton()) {
                printf("Restoring 0x004...");
                memset(buffer, 0, 512);
                sceIdStorageReadLeaf(0x005, buffer);
                sceIdStorageWriteLeaf(0x004, buffer);
                printf("done.\n");
                printf("\nCopy complete - hard reset after the XMB reloads.\n");
        }

        sceKernelDelayThread(3000 * 3000);
        sceKernelExitGame();

        return 0;
}
